#pragma once
#include <exception>
#include <string>

class BadFileFormatException : public std::exception {
  std::string error;
public:
  BadFileFormatException()     {
    error.assign("ERROR: Unknown or unsupported file format!");
  }
  explicit BadFileFormatException(const std::string& file_format) {
    error.assign("ERROR: File format \"" + file_format + "\" is not supported!");
  }
  const char* what() const noexcept override {
    return error.c_str();
  }
};

class NoFileFoundException : public std::exception {
  std::string error;
public:
  NoFileFoundException()     {
    error.assign("ERROR: Can't open file! Maybe it doesn't exist.");
  }
  explicit NoFileFoundException(const std::string& file_) {
    error.assign("ERROR: Can't open file: \"" + file_ + "\"! Maybe it doesn't exist.");
  }
  const char* what() const noexcept override {
    return error.c_str();
  }
};
