#pragma once
#include <fstream>
#include <vector>
#include <set>

#include "DataTypes.h"


//!!! Где main с тестированием?

//!!! Задание на защиту (не удалять!)
//!!! Реализовать на основе std::ranges 
//!!! 1. Сформировать контейнер всех узлов.
//!!! 2. С помощью потокового итератора вывести первые 10 ID узлов,
//!!!    которые лежат между двух сфер с общим центром и радиусами R1 и R2.



class MeshLoader {
protected:
  std::vector<Node> nodes;
  std::vector<FiniteElement> elements;
  std::vector<BoundaryFiniteElement> boundary;
public:
  virtual void LoadMesh(const std::string&) = 0;
  virtual ~MeshLoader() = default;
  void Print_Data();
  std::vector<Node>& Get_Nodes();
  std::vector<FiniteElement>& Get_Elements();
  std::vector<BoundaryFiniteElement>& Get_Surfaces();
  std::vector<FiniteElement> Get_Elements_by_ID(int, int, int);
  std::vector<FiniteElement> Get_Elements_by_rib(int, int);
  std::set<FiniteElement> Get_Elements_by_ID_area(int);
  std::set <Node> Get_top_nodes_by_border_ID(int);
  std::vector<BoundaryFiniteElement> Get_Borders_by_Border_ID(int);
  void Insert_New_Nodes();
  std::vector<std::set<int>> Get_Nodes_Neighbors();
  Node Get_Node_by_ID(int);
};